package sun.security.util;

import java.security.Key;
import java.security.AlgorithmParameters;
import java.security.CryptoPrimitive;
import java.util.Set;
import java.util.List;

public class LegacyAlgorithmConstraints extends AbstractAlgorithmConstraints
{
    public static final String PROPERTY_TLS_LEGACY_ALGS = "jdk.tls.legacyAlgorithms";
    private final List<String> legacyAlgorithms;
    
    public LegacyAlgorithmConstraints(String s, AlgorithmDecomposer algorithmDecomposer) {
        super(algorithmDecomposer);
        this.legacyAlgorithms = AbstractAlgorithmConstraints.getAlgorithms(s);
    }
    
    @Override
    public final boolean permits(Set<CryptoPrimitive> set, String s, AlgorithmParameters algorithmParameters) {
        return AbstractAlgorithmConstraints.checkAlgorithm(this.legacyAlgorithms, s, this.decomposer);
    }
    
    @Override
    public final boolean permits(Set<CryptoPrimitive> set, Key key) {
        return true;
    }
    
    @Override
    public final boolean permits(Set<CryptoPrimitive> set, String s, Key key, AlgorithmParameters algorithmParameters) {
        return AbstractAlgorithmConstraints.checkAlgorithm(this.legacyAlgorithms, s, this.decomposer);
    }
}
